# Net Tree

Turns a net into a tree.

**API:**

`recurse(items, ownerIds)`

Items are never mutated, `ownerIds` will be initialized with inferred defaults.

**Input:**

```javascript
[
  { id: 0, title: 'Root item' },
  { id: 1, superIds: [ 0 ], priorIds: { 0: 2 }, title: 'Second subitem' },
  { id: 2, superIds: [ 9, 3, 0 ], title: 'First subitem' },
  { id: 3, superIds: [ 1, 2, 9 ], title: 'Shared subitem of 1 & 2 & 3' },
  { id: 4, superIds: [ 1 ], title: 'First subitem of first subitem' },
  { id: 5, superIds: [ 1 ], priorIds: { 1: 6 }, title: 'Third subitem of first subitem' },
  { id: 6, superIds: [ 1 ], priorIds: { 1: 4 }, title: 'Second subitem of first subitem' },
  { id: 7, superIds: [ 2 ], title: 'First subitem of the second subitem' },
  { id: 8, superIds: [ 3 ], title: 'Subitem of the shared subitem' },
  { id: 9, superIds: [ 0 ], title: 'Third subitem' },
  { id: 10, superIds: [ 9 ], title: 'First subitem of third subitem' },
  { id: 11, superIds: [ 0, 11 ], title: 'Item in itself' }
]
```

- `id` is unique item identifier
- `superIds` are identifiers of super items
- `priorIds` are identifiers of prior items (dependencies for ordering) for the given super item
- `title` is the item title

**Output:**

![Screenshot](screenshot.png)

## Installing

[NPM package](https://www.npmjs.com/package/net-tree)

## Running

[Live demo](https://bloggo.herokuapp.com/post/net-tree/index.html)

`yarn start`

## Contributing

For stuff to do, see 9`doc/tasks`](doc/tasks).
